unit U_Tools;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, FieldEdit;

type
  TToolForm = class(TForm)
    Pages: TPageControl;
    Panel1: TPanel;
    BNClose: TButton;
    Label3: TLabel;
    PGTrans: TTabSheet;
    RGAxis: TRadioGroup;
    EBAngle: TEdit;
    BNRotate: TButton;
    Label5: TLabel;
    EBSfactor: TEdit;
    BNScale: TButton;
    Label6: TLabel;
    EBDX: TEdit;
    EBDY: TEdit;
    EBDZ: TEdit;
    BNTranslate: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    PDoor: TTabSheet;
    BNDoor: TButton;
    BNStraighten: TButton;
    BNFlip: TButton;
    CBScaleTX: TCheckBox;
    procedure BNCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BNRotateClick(Sender: TObject);
    procedure BNScaleClick(Sender: TObject);
    procedure BNTranslateClick(Sender: TObject);
    procedure BNDoorClick(Sender: TObject);
    procedure BNStraightenClick(Sender: TObject);
    procedure BNFlipClick(Sender: TObject);
  private
    { Private declarations }
    vangle,
    vdx,vdy,vdz,
    vsfactor:TvalInput;
  public

    { Public declarations }
  end;

var
  ToolForm: TToolForm;

implementation

uses Jed_Main,J_Level,Misc_utils,Lev_utils, U_Preview;

{$R *.DFM}

procedure TToolForm.BNCloseClick(Sender: TObject);
begin
 Hide;
end;

procedure TToolForm.FormCreate(Sender: TObject);
begin
 vangle:=TValInput.Create(EBAngle);
 vAngle.SetAsFloat(0);
 vsfactor:=TValInput.Create(EBSFactor);
 vsfactor.SetAsFloat(1);
 vdx:=TValInput.Create(EBDX); vdx.SetAsFloat(0);
 vdy:=TValInput.Create(EBDY); vdy.SetAsFloat(0);
 vdz:=TValInput.Create(EBDZ); vdz.SetAsFloat(0);
end;

procedure TToolForm.BNRotateClick(Sender: TObject);
var angle:double;
begin
 feValDouble(vangle.s,angle);
 JedMain.RotateObject(angle,RGAxis.ItemIndex);
end;

procedure TToolForm.BNFlipClick(Sender: TObject);
begin
 JedMain.FlipObject(RGAxis.ItemIndex);
end;

procedure TToolForm.BNScaleClick(Sender: TObject);
var sfactor:double;
    how:integer;
begin
 feValDouble(vsfactor.s,sfactor);
 if CBScaleTX.Checked then how:=sc_scaletx else how:=0;
 JedMain.ScaleObject(sfactor,how);
end;

procedure TToolForm.BNTranslateClick(Sender: TObject);
var dx,dy,dz:double;
begin
 feValDouble(vdx.s,dx);
 feValDouble(vdy.s,dy);
 feValDouble(vdz.s,dz);
 JedMain.TranslateObject(dx,dy,dz);
end;

procedure TToolForm.BNDoorClick(Sender: TObject);
begin
 JedMain.MakeDoor;
end;

procedure TToolForm.BNStraightenClick(Sender: TObject);
var i,j:integer;
begin
 for i:=0 to Level.Sectors.count-1 do
 With Level.Sectors[i] do
 for j:=0 to surfaces.count-1 do
 With Surfaces[j] do RecalcAll;
 Preview3D.ReloadLevel;
 JedMain.LevelChanged;
end;


end.
